;*****************************************************
; Dsactivation de l'autointerrupt de la synchro
;*****************************************************

synchro_off:
	move.l			d0,-(sp)
	move.w		#$0700,d0
	trap			#1			; Dsactive les auto-interruptions
	bclr.b			#2,$600001		; Autorise l'accs aux vecteurs
	move.l			old_int_1(pc),$64	; Restaure l'ancienne adresse
	bset.b			#2,$600001		; Interdit l'accs aux vecteurs
	trap			#1			; Active les auto-interruptions
	movem.l		(sp)+,d0
	rts

;*****************************************************
; Activation de l'autointerrupt de la synchro
;*****************************************************

synchro_on:
	move.l			d0,-(sp)
	move.w		#$0700,d0
	trap			#1
	move.l			$64,old_int_1		; Conserve la vieille interruption
	bclr.b			#2,$600001
	move.l			#int_1,$64		; Valide l'interruption perso
	bset.b			#2,$600001
	trap			#1
	movem.l		(sp)+,d0
	rts

; int_1: auto int 1 handler
;-------------------------------------------------------------------------------

int_1:
	move.l			d0,-(sp)
	move.b		synchro,d0		; Code perso pour la synchro
	cmp.b			#12,d0			; 27 images/secondes (350Hz/12)
	beq			wait
	add.b			#1,d0
	move.b		d0,synchro
wait:
	movem.l		(sp)+,d0
	rte

;*****************************************************
; Indicateur de synchronisation
;*****************************************************

synchro	dc.b	0

;*****************************************************

old_int_1	dc.l	0