;********* Sub - routines ****


;********* Textes ******
; Afficher les chanes

; A0 = Premier cran					.L
; A1 = Second cran					.L
; A2 = Pointeur vers la structure			.L

put_text:
	add		#1024,a0
	add		#1024,a1
\LOOP
	clr.w		d0
	move.b	(a2)+,d0
	beq.s		\END
	clr.w		d1
	move.w	#32,Taille_ecran
	move.b	(a2)+,d1
	move.b	(a2)+,d2
	movem.l	a0-a2,-(a7)
	bsr		put_string
	movem.l	(a7)+,a0-a2
\VERIF
	move.b	(a2)+,d0
	beq.s		\LOOP
	bra		\VERIF
\END
	rts

;*********** String ******
; Afficher String

; D0 = Coordonnes X					.W
; D1 = Coordonnes Y					.W
; D2 = Type de Fonte					.B
; Taille_ecran en octets				.W
; A0 = Premier cran					.L
; A1 = Second cran					.L
; A2 = Pointeur vers la chaine de caractres		.L

put_string:
	IFD ti92
	move.l		#tios::SF_font+$0600,a3	; Charge l'adresse de fonte en a3
	ENDIF
	IFND ti92
	move.l		#doorsos::font_medium,a3	; Charge l'adresse de fonte en a3
	ENDIF
	move.w	#7,d7
	tst.b		d2
	bne		\No_BIG
	move.w	#9,d7
	IFND ti92
	add		#$E00,a3		; Pointe sur la grande fonte
	ENDIF
	IFD ti92
	move.l		#tios::SF_font+$0E00,a3	; Charge l'adresse de fonte en a3
	ENDIF
	bra		\Choix_FonteOK
\No_BIG
	cmp.b		#2,d2
	bne		\Choix_FonteOK		; ..moyenne fonte
	move.w	#5,d7
	IFD ti92
	move.l		#tios::SF_font+1,a3	; Charge l'adresse de fonte en a3
	ENDIF
	IFND ti92
	add		#$801,a3
	ENDIF
\Choix_FonteOK
	lsl.w		#5,d1			; Calcul des coordonnes Y
	move.w	d0,d3			; Calcul des coordonnes X
	and.b		#7,d3
	move.b	#8,d2
	sub		d3,d2			; D2 = Reste
	lsr.w		#3,d0
	add		d1,d0
	add		d0,a0			; Premier cran positionn
	add		d0,a1			; Second cran positionn
\LOOP
	clr.w		d0
	move.b	(a2)+,d0		; Test de fin de chane
	beq		\END
	move.w	d7,d6
	add		#1,d6
	mulu.w		d6,d0
	move.l		a3,a4			; A3 = Pointeur sur fonte
	add		d0,a4			; A4 = Pointeur sur caractre
	movem.l		a0-a1,-(a7)
	move.w		d7,d6
	cmp.b		#5,d7
	bne		\PUT
	sub		#1,d6
\PUT
	clr.w		d0
	move.b	(a4)+,d0
	lsl.w		d2,d0
	or.b		d0,1(a0)
	move.b	d0,1(a1)
	lsr.w		#8,d0
	or.b		d0,(a0)
	or.b		d0,(a1)
	move.w	Taille_ecran,d0
	add.w		d0,a0
	add.w		d0,a1
	dbra.w		d6,\PUT
	movem.l		(a7)+,a0-a1
	lea		1(a0),a0
	lea		1(a1),a1
	cmp.b		#9,d7
	beq		\LOOP
	cmp.b		#7,d7
	bne		\Put_Small_Font
	move.w		#1,d5
	bra		\Correction
\Put_Small_Font
	move.w		#3,d5
\Correction
	cmp.b		#8,d2
	bne		\Sub_OK
	move.b		#0,d2
	sub		#1,a0
	sub		#1,a1
	dbra.b		d5,\Correction
	bra		\LOOP
\Sub_OK
	add		#1,d2
	dbra.b		d5,\Correction
	bra		\LOOP
\END
	rts

;*********** Scroll ******
; Dessiner scroll

scroll:
	clr.l		d3
	move.b	scroll_pos,d3
	add		#1,d3
	cmp.b		#31,d3
	bne		continu
	move.b	#0,d3
continu:
	move.b	d3,scroll_pos
	lsl.l		#5,d3
	move.w	anim_scroll,d0
	move.w	d0,d1
	lsr		#2,d0
	lsl.w		#7,d0
	lea		scroll_def,a2
	add.w		d0,a2
	tst.b		d1
	beq		reset_anm
	sub		#1,d1
	move.w	d1,anim_scroll
	bra		suite_anm
reset_anm:
	move.w	#20,anim_scroll
suite_anm:
	move.w	#7,d6
boucle_draw_scrollx:
	move.w	#4,d5
boucle_draw_scrolly:
	move.l		save_add11,a0			; Charge les adresses
	move.l		save_add21,a1
	clr.l		d0
	clr.l		d1
	move.w	d5,d0
	lsl.l		#8,d0
	lsl.l		#2,d0
	move.w	d6,d1
	lsl.w		#2,d1
	add		d0,d1
	add		d3,d1
	add		d1,a0
	add		d1,a1
	move.l		a2,a3
	move.w	#31,d4
boucle_draw_scrollz:
	move.l		#$FFFFFFFF,(a1)
	move.l		(a3)+,(a0)
	add		#32,a0
	add		#32,a1
	dbra.b		d4,boucle_draw_scrollz
	dbra.b		d5,boucle_draw_scrolly
	dbra.b		d6,boucle_draw_scrollx
	rts

;*********** Menu1 ******
; Dessiner Menu1

draw_menu1:
	move.l		save_add21,a0
	add		#2376,a0
	move.w	#79,d2
boucle_menuy1:
	move.w	#13,d1
boucle_menux1:
	move.b	#0,(a0)+
	dbra.b		d1,boucle_menux1
	add		#18,a0
	dbra.b		d2,boucle_menuy1
	rts

;*********** Menu2 ******
; Dessiner Menu2

draw_menu2:
	move.l		save_add21,a0
	add		#2373,a0
	move.w	#79,d2
boucle_menuy2:
	move.w	#19,d1
boucle_menux2:
	move.b	#0,(a0)+
	dbra.b		d1,boucle_menux2
	add		#12,a0
	dbra.b		d2,boucle_menuy2
	rts

;*********** Menu3 ******
; Dessiner Menu3

draw_menu3:
	move.l		save_add11,a0
	add		#2383,a0
	move.w	#40,d2
boucle_menuy3:
	move.w	#9,d1
boucle_menux3:
	move.b	#0,(a0)+
	dbra.w		d1,boucle_menux3
	add		#22,a0
	dbra.w		d2,boucle_menuy3
	rts

;*********** Titre ******
; Dessiner Titre

	IFND ti89
title:
	move.l		save_add11,a0
	move.l		save_add21,a1
	lea		titre,a2
	add		#1024,a0
	add		#1024,a1
	move.w	#37,d0
titre_by:
	move.w	#14,d1
titre_bx:
	move.w	(a2)+,d2
	not.w		d2
	and.w		d2,(a0)+
	and.w		d2,(a1)+
	dbra.b		d1,titre_bx
	add		#2,a0
	add		#2,a1
	dbra.b		d0,titre_by
	rts
	ENDIF

;*********** AboutMenu ******
; Dessiner AboutMenu

aboutmenu:
	move.l		save_add11,a0
	move.l		save_add21,a1
	add		#2501,a0
	add		#2501,a1
	move.w	#71,d0
aboutmenu_by:
	move.w	#19,d1
aboutmenu_bx:
	move.b	(a2)+,d2
	or.b		d2,(a0)+
	or.b		d2,(a1)+
	dbra.b		d1,aboutmenu_bx
	add		#12,a0
	add		#12,a1
	dbra.b		d0,aboutmenu_by
	rts

;*********** OptionsMenu ******
; Dessiner OptionsMenu

optionsmenu:
	move.l		save_add11,a0
	move.l		save_add21,a1
	add		#2438,a0
	add		#2438,a1
	move.w	#75,d0
optionsmenu_by:
	move.w	#7,d1
optionsmenu_bx:
	move.b	(a2)+,d2
	or.b		d2,(a0)+
	or.b		d2,(a1)+
	dbra.b		d1,optionsmenu_bx
	add		#24,a0
	add		#24,a1
	dbra.b		d0,optionsmenu_by
	rts

;*********** ScrollChange ******
; Dessiner ScrollChange

scrollchange:
	move.l		save_add11,a0
	move.l		save_add21,a1
	lea		scroll_option,a2
	move.l		scrolling,d0
	mulu		#1020,d0
	add		d0,a2
	move.l		a2,a3
	add		#510,a3
	add		#2383,a0
	add		#2383,a1
	move.w	#50,d0
scrolloptions_by:
	move.w	#9,d1
scrolloptions_bx:
	move.b	(a2)+,d2
	or.b		d2,(a0)+
	move.b	(a3)+,d2
	or.b		d2,(a1)+
	dbra.b		d1,scrolloptions_bx
	add		#22,a0
	add		#22,a1
	dbra.b		d0,scrolloptions_by
	rts

;*********** Contrast ******
; Dessiner Contrast

contrast:
	move.l		save_add11,a0
	move.l		save_add21,a1
	lea		contraste,a2
	add		#4114,a0
	add		#4114,a1
	move.w	#11,d0
contrast_by:
	move.w	#3,d1
contrast_bx:
	move.b	(a2)+,d2
	or.b		d2,(a0)+
	or.b		d2,(a1)+
	dbra.b		d1,contrast_bx
	add		#28,a0
	add		#28,a1
	dbra.b		d0,contrast_by
	rts

;*********** MainCurseur ******
; Dessiner MainCurseur

maincurseur:
	move.l		save_add11,a0
	move.l		save_add21,a1
	move.l		main_curseur,d0
	add		#2409,a0
	add		#2409,a1
	mulu		#416,d0
	add		d0,a0
	add		d0,a1
	move.w	#12,d0
maincurseur_by:
	move.w	#11,d1
maincurseur_bx:
	not.b		(a0)+
	not.b		(a1)+
	dbra.b		d1,maincurseur_bx
	add		#20,a0
	add		#20,a1
	dbra.b		d0,maincurseur_by

	move.w	continue_game,d0
	tst.b		d0
	bne		no_continu_clear

	move.l		save_add21,a0			; Charge les adresses
	add		#1024+(32*56)+8,a0
	move.w	#12,d1
\boucle_continu
	clr.l		(a0)+
	clr.l		(a0)+
	clr.l		(a0)+
	clr.b		(a0)
	add		#20,a0
	dbra		d1,\boucle_continu
no_continu_clear:
	rts

;*********** SecondCurseur ******
; Dessiner SecondCurseur

secondcurseur:
	move.l		save_add11,a0
	move.l		save_add21,a1
	move.l		second_curseur,d0
	add		#2406,a0
	add		#2406,a1
	mulu		#416,d0
	add		d0,a0
	add		d0,a1
	move.w	#12,d0
secondcurseur_by:
	move.w	#7,d1
secondcurseur_bx:
	not.b		(a0)+
	not.b		(a1)+
	dbra.b		d1,secondcurseur_bx
	add		#24,a0
	add		#24,a1
	dbra.b		d0,secondcurseur_by
	rts

;***********************
; Lecture des touches
; Menu principal
;***********************

movemain_curseur:
	move.l		main_curseur,d0
	IFND ti89
	move.w	#3,d1
	ENDIF
	IFD ti89
	move.w	#4,d1
	ENDIF
	bsr		get_key
	bne		no_enter
	cmp		#5,d0
	bne		no_quit
	move.w	#1,quit
no_quit:
	cmp		#2,d0
	bne		no_high
	move.w	#2,position
no_high:
	cmp		#3,d0
	bne		no_options
	move.w	#3,position
no_options:
	cmp		#4,d0
	bne		no_about
	move.w	#4,position
no_about:
no_enter:
	IFND ti89
	move.w	#7,d1
	ENDIF
	IFD ti89
	move.w	#2,d1
	ENDIF
	bsr		get_key
	beq		no_up
	tst.b		d0
	bne		nodowncurseur
	move.b	#6,d0
nodowncurseur:
	sub		#1,d0
	move.l		d0,main_curseur	
no_up:
	IFND ti89
	move.w	#5,d1
	ENDIF
	IFD ti89
	move.w	#0,d1
	ENDIF
	bsr		get_key
	beq		no_down
	cmp.b		#5,d0
	bne		noupcurseur
	move.l		#$FFFFFFFF,d0
noupcurseur:
	add		#1,d0
	move.l		d0,main_curseur
no_down:
	rts

;***********************
; Lecture des touches
; Menu secondaire
;***********************

movesecond_curseur:
	move.l		second_curseur,d0
	IFND ti89
	move.w	#3,d1
	ENDIF
	IFD ti89
	move.w	#4,d1
	ENDIF
	bsr		get_key
	bne		no_enter2
	cmp		#5,d0
	bne		no_quit2
	move.w	#0,position
no_quit2:
	cmp		#0,d0
	bne		no_enter2
	move.l		scrolling,d1
	cmp		#1,d1
	bhi		resetscrollchange
	add		#1,d1
	move.l		d1,scrolling
	bra		no_enter2
resetscrollchange:
	move.l		#0,scrolling
no_enter2:
	cmp		#4,d0
	bne		nocontrastchange
	IFND ti89
	move.w	#6,d1
	ENDIF
	IFD ti89
	move.w	#3,d1
	ENDIF
	bsr		get_key
	bne		nocontrastchangea
	move.l		d0,-(a7)
	move.b	#9,d0
	trap		#9
	jsr		(a0)
	move.l		(a7)+,d0
nocontrastchangea:
	IFND ti89
	move.w	#4,d1
	ENDIF
	IFD ti89
	move.w	#1,d1
	ENDIF
	bsr		get_key
	bne		nocontrastchange
	move.l		d0,-(a7)
	move.b	#10,d0
	trap		#9
	jsr		(a0)
	move.l		(a7)+,d0
nocontrastchange:
	IFND ti89
	move.w	#5,d1
	ENDIF
	IFD ti89
	move.w	#0,d1
	ENDIF
	bsr		get_key
	bne		no_up2
	tst.b		d0
	bne		nodowncurseur2
	move.b	#6,d0
nodowncurseur2:
	cmp		#4,d0
	bne		nospecup
	move.l		#0,second_curseur
	bra		no_down2
nospecup:
	sub		#1,d0
	move.l		d0,second_curseur
no_up2:
	IFND ti89
	move.w	#7,d1
	ENDIF
	IFD ti89
	move.w	#2,d1
	ENDIF
	bsr		get_key
	bne		no_down2
	cmp.b		#5,d0
	bne		noupcurseur2
	move.l		#$FFFFFFFF,d0
noupcurseur2:
	tst.b		d0
	bne		nospecdown
	move.l		#4,second_curseur
	bra		no_down2
nospecdown:
	add		#1,d0
	move.l		d0,second_curseur
no_down2:
	rts


;*****************************
; Cration mmoire virtuelle
;*****************************

create_memory:
	move.l		#12288,-(a7)
	IFD ti92
	jsr		tios::HeapAlloc
	ENDIF
	IFND ti92
	jsr		doorsos::HeapAlloc
	ENDIF
	lea		4(a7),a7
	move.w	d0,save_handlem
	IFD ti92
	tios::DEREF	d0,a0
	ENDIF
	IFND ti92
	doorsos::DEREF	d0,a0
	ENDIF
	move.l		a0,save_add11
	add		#6144,a0
	move.l		a0,save_add21
	rts

;********************************
; Destruction mmoire virtuelle
;********************************

destroy_memory:
	move.w	save_handlem,-(a7)
	IFD ti92
	jsr		tios::HeapFree
	ENDIF
	IFND ti92
	jsr		doorsos::HeapFree
	ENDIF

	lea		2(a7),a7
	rts


start_solar:
	;***** Start : Initialisation de SolarStriker *****

	create_memory			; Memoire virtuelle
	tst.b		d0
	beq		no_mem1		; Pas assez de mmoire, quitter...

	;***** End : Initialisation de solarstriker *****


	move.l		current_level,d0	; Charge level courant
	move.w	#1,continue_game

	; ASTUCE POUR CHARGER LE NIVEAU DE DEPART !
	; mettre le numro du niveau voulu (1..) dans D0

	bsr		initialize_level

	move.l		main_curseur,d0
	tst.b		d0
	beq		skip_continue_test
	move.w	continue_game,d0
	tst.b		d0
	beq		shift_ok
	bra		continue_test
skip_continue_test:
	move.w	#1,continue_game
continue_test:
	board_info				; Tableau d'informations
	put_life				; Affichage des vies
	bsr		convert_score
	bsr		Put_score

main_boucle:
	; Utilisation de la synchro

	move.b	synchro,d0
	cmp.b		#12,d0
	beq		synchro_ok		; Passe si synchro = 12
	bra		main_boucle		; Boucle si synchro<12

synchro_ok:

	read_key					; Lis les touches
	test_shift				; Si shift alors quitter
	test_second				; Si 2nd alors pause (off)

	move.b	#0,synchro			; Reset la synchro

	move.w	position_niveau,d0
	add		#1,d0
	move.w	d0,position_niveau			; Update la position du niveau

	copy_bck_to_vmem

	move_ship				; Update Vaisseau
	move_fire				; Update Feux
	put_explode				; Placer explosions (1)
	start_ennemy				; Dmarrer un ennemi ventuel
	place_ennemy				; Placer ennemis (2)
	put_ennemy_fire			; Afficher les tirs ennemis
	move_bonus				; Dplacement bonus
	verif_newship

	move.w	no_put_ship_ok,d0
	tst.w		d0
	bne		no_put_shipcondition
	put_fire					; Placer les feus

	move.b	recall_sprite,d0
	tst.b		d0
	bne		put_shipcondition
	put_ship				; Placer le vaisseau
	bra		no_put_shipcondition
put_shipcondition:
	subq.b		#1,d0
	move.b	d0,recall_sprite
	and.b		#2,d0
	tst.b		d0
	beq		no_put_shipcondition
	put_ship				; Placer vaisseau
no_put_shipcondition:

	wait_kill
	copy_vmem_to_tscr			; Place vmem en true_screen

	move.w	no_put_ship_ok,d0
	tst.w		d0
	beq		no_fin_trans
	sub		#1,d0
	move.l		#176,xship
	move.l		#143,yship
	tst.w		d0
	bne		no_fin_trans
	move.w	#0,continue_game
	bsr		start_fin_transition	; Transition de fin (mort)
no_fin_trans:
	move.w	d0,no_put_ship_ok

	move.w	position_niveau,d0
	move.l		niveau_run,a0
	move.w	(a0),d1
	cmp.w		d0,d1			; Si position_niveau = Fin_niveau
	bne		no_next_level		; alors quitter

	bsr		transition_niveau
	reinit_variables			; Reset pour nouveau jeu
	move.b	vies,d0
	add		#1,d0
	move.b	d0,vies
	move.l		current_level,d0	; Charge level suivant
	add		#1,d0
	move.l		d0,current_level
	move.w	#-31,position_scrolling1
	move.w	#-31,position_scrolling2
	move.w	#-31,position_scrolling3
	move.w	#0,continue_game
	move.l		#0,main_curseur
	bsr		initialize_level
	move.w	#1,continue_game
	board_info				; Tableau d'informations
	put_life				; Affichage des vies
	bsr		convert_score
	bsr		Put_score
	bra		main_boucle
no_next_level:

	move.w	perduint,d0		; Si perduint = 1 ...
	tst.b		d0			; ... alors ...

	beq		main_boucle		; ... quitter !
	move.b	recall_sprite,d0
	tst.b		d0
	beq		nomain_boucle_next
	move.w	#0,perduint
	bra		main_boucle
nomain_boucle_next:
	move.b	vies,d0
	tst.b		d0
	bne		next_shift_ok
	move.w	#80,no_put_ship_ok
	move.b	#1,recall_sprite
	move.w	#0,perduint
	move.l		xship,d0
	move.l		yship,d1
	sub		#8,d0
	sub		#8,d1
	lea		explod_coord,a0
	lea		56(a0),a0
	move.b	#2,(a0)+
	move.b	d0,(a0)+
	move.b	d1,(a0)+
	move.b	#0,(a0)+
	move.l		#188,xship
	bra		main_boucle
next_shift_ok:
	sub		#1,d0
	move.b	d0,vies
	retirer_arme
	move.w	#0,perduint
	move.l		xship,d0
	move.l		yship,d1
	sub		#8,d0
	sub		#8,d1
	lea		explod_coord,a0
	lea		56(a0),a0
	move.b	#2,(a0)+
	move.b	d0,(a0)+
	move.b	d1,(a0)+
	move.b	#0,(a0)+
	move.l		#89,yship
	move.w	#159,startship
	move.b	#120,recall_sprite
	put_life
	bra		main_boucle

pause_ok:
	bsr		afficher_pause

	bra		main_boucle

shift_ok:					; On quitte le jeu !

	;***** Start : Shutdown de SolarStriker *****
	destroy_memory			; Efface la memoire virtuelle
no_mem1:					; Pas de mem dispo
	;***** End : Shutdown de solarstriker *****
	rts