	IFD ti92
FOLDERLIST_HDL	equ	$0B
VATENTRY_SIZE	equ	12
	ENDIF

	IFND ti92
tios::HeapFree		equ	doorsos::HeapFree
tios::HeapAlloc	equ	doorsos::HeapAlloc
tios::HeapRealloc 	equ 	doorsos::HeapRealloc
tios::DrawStrXY	equ	doorsos::DrawStrXY
tios::FontSetSys	equ	doorsos::FontSetSys
tios::kb_globals	equ	doorsos::ST_busy
tios::ST_busy		equ	doorsos::ST_busy
tios::DEREF 		MACRO
	doorsos::DEREF \1,\2
	ENDM
FOLDERLIST_HDL	equ	doorsos::FolderListHandle
VATENTRY_SIZE	equ	14
	ENDIF

	IFND ti89
PAD_UP		equ     338
PAD_DOWN		equ     344
	ENDIF

	IFD ti89
PAD_UP		equ     337
PAD_DOWN		equ     340
	ENDIF

;**********************************************************************************
;-----------------------------------------------------
; Affiche la liste de selection des fichiers niveaux
; pour Solar Striker.
; (N'Affiche pas la boite de selection elle meme !!
;  seulement la liste)
;
;Input>	Rien
;Out>	d0.w : 	0 if error
;		else hdl of selected file
;	a0.l : If successfull, (d0.w<>0)
;		a0.l is the address of selected file
;		else a0.l is null
;-----------------------------------------------------
SelectLevel:
	movem.l	d1-d7/a1-a6,-(a7)

	bsr	MakeBuffer		;create buffer
	move.w	d0,d7			;save buffer hdl
	beq.s	\error			;if null, exit
	
	bsr	DEREFd0a0		;hdl of buffer
	move.w	(a0)+,d2		;nb items found
	beq.s	\nolvl			;if no item found, exit
	subq.w	#1,d2			;NbItem-1

	move.l	a0,-(a7)
	lea	OpenWin(PC),a0
	bsr	draw_Window
	move.l	(a7)+,a0

	IFND ti89
	moveq.w	#46,d0			;X
	moveq.w	#40,d1			;Y
	ENDIF
	IFD ti89
	moveq.w	#6,d0			;X
	moveq.w	#40,d1			;Y
	ENDIF
	moveq.w	#4,d3			;nbitem per page
	moveq.w	#%00000111,d4		;flags
	moveq.w	#18,d5			;Listwidth
	moveq.w	#2,d6			;ItemSize
	lea	CallBack_Key(PC),a1
	lea	CallBack_DrawItem(PC),a3 ;addr of callback fct
	bsr	ListView
	cmp.w	#264,d0
	bne.s	\noesc
	clr.w	d0
	bra.s	\exit

\noesc	move.w	d1,d0			;hdl of file
\exit	move.l	#0,a0
	tst.w	d7			;check if buffer
	beq.s	\nobuf			;has been created
	move.l	d0,-(a7)		;save d0
	move.w	d7,-(a7)		;free buffer
	jsr	tios::HeapFree
	addq.l	#2,a7
	move.l	(a7)+,d0		;restore d0
	bsr	DEREFd0a0		;Get address
\nobuf	movem.l	(a7)+,d1-d7/a1-a6
	rts

;-----------------------------------------------------
; Show Error Message
;-----------------------------------------------------
\error	lea	lvlerr2(PC),a1
	bra.s	\showmsg
\nolvl	lea	lvlerr1(PC),a1
\showmsg lea	ErrWin(PC),a0
	bsr	draw_Window
	IFND ti89
	moveq.w	#45,d0
	moveq.w	#55,d1
	ENDIF
	IFD ti89
	moveq.w	#5,d0
	moveq.w	#55,d1
	ENDIF
	bsr	DrawStringSpecial
	jsr	KB_WAIT
	clr.l		d0
	bra.s	\exit


;-----------------------------------------------------
;
;-----------------------------------------------------
CallBack_Key:
	cmp.w	#264,d0			;if esc
	beq.s	\exit			;exit

	move.w	(a1),d1			;hdl of slct file
	cmp.w	#13,d0			;if enter
	beq.s	\exit			;exit

	clr.w	d0
\exit	rts

;-----------------------------------------------------
;
;-----------------------------------------------------
CallBack_DrawItem:
	move.w	d0,d2			;save d0=x
	move.w	(a1),d0			;Get hdl
	bsr	DEREFd0a0		;get addr
	move.l	12(a0),d0
	lea	2(a0,d0.l),a1

	addq.w	#1,d1			;y
	move.w	d2,d0			;x
	bsr	DrawStringSpecial
	rts

;-----------------------------------------------------
; MakeBuffer
;
; Cherche les levels de type Solar Striker
; dans tous les rpertoires de la calculatrice
; et cre un buffer contenant le handle de chaque
; fichiers valides trouvs.
;
;Input>	Rien
;out>	d0.w : 	0 si erreur
;		ou sinon le handle du buffer cr
;-----------------------------------------------------
MakeBuffer:
	movem.l	d1-d7/a0-a6,-(a7)

	moveq.l	#4,d0			;cr un buffer de 4 octets
	move.l	d0,-(a7)
	jsr	tios::HeapAlloc
	addq.w	#4,a7
	tst.w	d0
	beq	\exit			;d0=0 if error 
	bsr	DEREFd0a0
	clr.w	(a0)+			;clear nb of items

	move.w	d0,d7			;hdl of buffer

	move.w	#FOLDERLIST_HDL,d0
	bsr	DEREFd0a0		;get addr of Folder table
	lea	2(a0),a3		;skip first word

	clr.w	d0			;set 0 if error
	move.w	(a3)+,d3
	beq.s	\error
	subq.w	#1,d3			;for dbra

\folder	move.w	VATENTRY_SIZE-2(a3),d0	;hdl of folder
	bsr	DEREFd0a0		;addr of associated files
	lea	2(a0),a2		;skip first word
	move.w	(a2)+,d2		;nb of files in folder
	beq.s	\next_folder		;if null, skip
	subq.w	#1,d2			;for dbra

\files	move.w	VATENTRY_SIZE-2(a2),d0	;hdl of file
	beq.s	\next_file		;check if valid
	bsr	DEREFd0a0		;get hdl of file
	move.w	(a0)+,d0		;size of file
	cmp.b	#$2D,-1(a0,d0.w)	;Check if a string
	bne.s	\next_file
	cmp.l	#'SS68',(a0)
	bne.s	\next_file

	;else add item
	move.w	d7,d0			;buffer hdl
	bsr	DEREFd0a0		;addr of buffer
	addq.w	#1,(a0)			;
	move.w	(a0)+,d4		;nb copied
	lsl.w	#1,d4			;d0*2
	move.w	VATENTRY_SIZE-2(a2),d5
	addq.w	#2,d4
	ext.l	d4
	movem.l	d1-d2/a0-a2,-(a7)
	move.l	d4,-(a7)
	move.w	d7,-(a7)
	jsr	tios::HeapRealloc
	addq.l	#6,a7
	movem.l	(a7)+,d1-d2/a0-a2
	tst.w	d0
	bne.s	\noerror
\error	movem.l	d0-d2/a0-a1,-(a7)	;if error,
	move.w	d7,-(a7)		;delete
	jsr	tios::HeapFree		;buffer
	addq.l	#2,a7
	movem.l	(a7)+,d0-d2/a0-a1
	bra.s	\exit

\noerror move.w	d0,d7
	bsr	DEREFd0a0
	move.w	d5,-2(a0,d4.w) ;put item
	
\next_file
	lea	VATENTRY_SIZE(a2),a2
	dbra.s	d2,\files

\next_folder
	lea	VATENTRY_SIZE(a3),a3
	dbra.s	d3,\folder
	
	move.w	d7,d0			;return hdl of buffer

\exit	movem.l	(a7)+,d1-d7/a0-a6
	rts






;-----------------------------------------------------
; ListView function
;-----------------------------------------------------
DrawItemFct     dc.l    0
CharHeight      dc.w    0
ListWidth       dc.w    0
NbItemPerPage   dc.w    0
NbItem          dc.w    0
ItemSize        dc.w    0
Flags           dc.b    0
		dc.b	0

ListView:
	movem.l d2-d7/a1-a6,-(a7)

	move.l  a1,a6
	move.w  d6,ItemSize
	move.l  a3,DrawItemFct
	lea     Flags(PC),a3
	lea     NbItemPerPage(PC),a4
	lea     NbItem(PC),a2
	move.w  d2,(a2)                 ;NbItem
	move.b  d4,(a3)                 ;Flags
	move.w  d3,(a4)                 ;NbItemPerPage
	move.w  d0,d3                   ;X
	move.w  d1,d4                   ;Y
	move.l  a0,a5
	clr.w   d6
	clr.w   d7

	moveq.w	#8,d0			;bsr     GetFontWidthHeight
	moveq.w	#9,d1
	move.w  d1,CharHeight
	mulu.w  d5,d0                           ;width*nbchar
	addq.w  #4,d0                           ;two pixels each side
	move.w  d0,ListWidth

lvRD    bsr     DrawListView
	bsr     lvSelectItem

lvWaitKB jsr    KB_WAIT
	cmp.w   #PAD_DOWN,d0
	beq     lv_down
	cmp.w   #PAD_UP,d0
	beq     lv_up

	movem.l d2-d7/a1-a6,-(a7)
	bsr     ItemAddr
	jsr     (a6)
	movem.l (a7)+,d2-d7/a1-a6

	cmp.w   #$FFFF,d0
	beq.s   lvRD

	tst.w   d0
	beq.s   lvWaitKB

	movem.l (a7)+,d2-d7/a1-a6
	rts

lv_up:
	tst.w   d6
	beq.s   \noup
	bsr     lvSelectItem            ;deselect item
	subq.w  #1,d6
	tst.w   d7
	bne.s   \noscroll
	bsr     DrawListView
	addq.l  #1,d7
\noscroll subq.w #1,d7
	bsr     lvSelectItem
\noup   bra     lvWaitKB


lv_down:
	cmp.w   (a2),d6                 ;NbItem
	beq.s   \nodown
	bsr     lvSelectItem            ;deselect item
	addq.w  #1,d6
	cmp.w   (a4),d7
	bne.s   \noscoll
	bsr     DrawListView
	subq.w  #1,d7
\noscoll addq.w #1,d7
	bsr     lvSelectItem
\nodown bra     lvWaitKB


;return the addr of an item
;in>    d6.w = item index
;out>   a1.l = addr of item
ItemAddr:
	move.l  d0,-(a7)

	move.l  a5,a1           ;a5=addr of items data
	move.w  d6,d0           ;if first item, skip
	beq.s   \skip
	mulu.w  ItemSize,d0     ;x constant size
	adda.w  d0,a1

\skip	move.l  (a7)+,d0
	rts

DrawListView:
	move.l  d6,-(a7)

	move.w  d4,-(a7)        ;Y2
	move.w  (a4),d0
	addq.w  #1,d0
	mulu.w  CharHeight,d0           ;NbItemPerPage
	add.w   d0,(a7)         
	addq.w  #2,(a7)
	move.w  d3,-(a7)        ;X2
	move.w  ListWidth,d0
	add.w   d0,(a7)
	move.w  d4,-(a7)        ;Y
	move.w  d3,-(a7)        ;X
	jsr     draw_EraseRect
	addq.l  #8,a7


	move.w  d6,d0
	sub.w   d7,d0           ;first item showed
	move.w  d0,d6           ;For CallBackDrawItem & ItemAddr

	bsr     ItemAddr        ;a1=item addr

	move.w  (a2),d2         ;NbItem
	sub.w   d0,d2
	cmp.w   (a4),d2
	bcs.s   \skip2
	move.w  (a4),d2
\skip2  move.w  d3,d0           ;X
	move.w  d4,d1           ;Y
	addq.w  #2,d0
	addq.w  #2,d1

\loop	movem.l d0-d7/a0-a6,-(a7)
	move.w  ListWidth,d3
	move.l  DrawItemFct,a0
	jsr     (a0)                    ;d0=X,d1=Y,a1=item string
	movem.l (a7)+,d0-d7/a0-a6

\sdraw  add.w   CharHeight,d1
	adda.w  ItemSize,a1
	addq.w  #1,d6
	dbra.s  d2,\loop

	move.l  (a7)+,d6
	rts

lvSelectItem:
	movem.l d0-d7,-(a7)
	move.w  d3,d0                   ;X1
	addq.w  #1,d0
	move.w  d7,d1
	move.w  CharHeight,d3           ;Height
	mulu.w  d3,d1
	addq.w  #1,d3
	add.w   d4,d1                   ;Y1
	addq.w  #1,d1
	move.w  ListWidth,d2            ;Width
	subq.w  #1,d2
	bsr     InvertArea      
	movem.l (a7)+,d0-d7
	rts


;-----------------------------------------------------
; Small function for size-optimization
;-----------------------------------------------------
DEREFd0a0:
	tios::DEREF d0,a0
        lsr.w   #2,d0                   ;restore hdl
        rts


;*****************************************************
; prep_rect: used by frame_rect and erase_rect
;*****************************************************
prep_rect:
	move.l	#0,d4
        move.w  $36(a7),d4
	move.w	d4,d5
	lsl.w	#5,d4
	lsl.w	#1,d5
	sub.w	d5,d4
	add.l	#LCD_MEM,d4
	move.l	d4,a0

	move.l	#0,d5
        move.w  $3A(a7),d5
	move.w	d5,d6
	lsl.w	#5,d5
	lsl.w	#1,d6
	sub.w	d6,d5
	add.l	#LCD_MEM,d5
	move.l	d5,a1

        move.w  $34(a7),d0
	move.w	d0,d6
	lsr.w	#3,d0
	and.w	#$7,d6

        move.w  $38(a7),d1
	move.w	d1,d7
	lsr.w	#3,d1
	and.w	#$7,d7

	rts


;-----------------------------------------------------
; Invert an area on the screen
;-----------------------------------------------------
InvertArea:
        movem.l a0/d0-d5,-(a7)

        move.l  #LCD_MEM,a0     ;memory address
        mulu.w  #30,d1          ;y*30
        adda    d1,a0
        subq.w  #1,d3

\lines  movem.l a0/d0/d2,-(a7)

        move.l  d0,d1           ;save d0
        lsr.w   #3,d1           ;int(d1/8)
        adda    d1,a0           ;
        lsl.w   #3,d1           ;d1*8
        move.w  d0,d4           ;d4=X
        sub.w   d1,d4           ;d4=d4-d1
        moveq.w #8,d5           ;
        sub.w   d4,d5           ;d5=8-d4
        sub.w   d5,d2           ;for after      

        tst.w   d5
        beq.s   \skip1
        subq.w  #1,d5
\lp     bchg.b  d5,(a0)
        dbra.s  d5,\lp

\skip1  move.w  d2,d1           ;save d2
        addq.l  #1,a0
        lsr.w   #3,d2
        move.w  d2,d4           ;save d2
        beq.s   \skip2          ;if d2=d4 = 0 skip
        subq.w  #1,d2
\lp2    not.b   (a0)+
        dbra.s  d2,\lp2

\skip2  lsl.w   #3,d4
        sub.w   d4,d1
        tst.w   d1
        beq.s   \no
        subq.w  #1,d1
        moveq.w #7,d2
\lp3    bchg.b  d2,(a0)
        subq.w  #1,d2
        dbra.s  d1,\lp3 
        
\no     movem.l (a7)+,a0/d0/d2
        lea     30(a0),a0       ;adda   #30,a0
        dbra.s  d3,\lines                       

        movem.l (a7)+,a0/d0-d5
        rts



;-----------------------------------------------------
; Draw a rect
;-----------------------------------------------------
draw_EraseRect:
        movem.l d0-d7/a0-a2,-(a7)

	bsr	prep_rect
	move.b	#$FF,d2
	move.b	#$FF,d3
	lsr.b	d6,d2
	move.w	#7,d6
	sub.w	d7,d6
	lsl.b	d6,d3
	not.b	d2
	not.b	d3

	not.b	d6
	move.l	a0,a2
vert_loop1:
	move.w	d0,d7
horz_loop1:
	clr.b	d6
	cmp.w	d0,d7
	bne	horz_not_left1
	or.b	d2,d6
horz_not_left1:
	cmp.w	d1,d7
	bne	horz_not_right1
	or.b	d3,d6
horz_not_right1:
	and.b	d6,0(a2,d7.w)
	add.w	#1,d7
	cmp.w	d1,d7
	bls	horz_loop1
        lea     30(a2),a2
	cmp.l	a1,a2
	bls	vert_loop1

        movem.l (a7)+,d0-d7/a0-a2
	rts

;-----------------------------------------------------
; Draw a rect
;-----------------------------------------------------
draw_FrameRect:
api92@0029:
        movem.l d0-d7/a0-a2,-(a7)

	bsr	prep_rect
	move.b	#$FF,d2
	move.b	#$FF,d3
	move.b	#$80,d4
	move.b	#$01,d5
	lsr.b	d6,d2
	lsr.b	d6,d4
	move.w	#7,d6
	sub.w	d7,d6
	lsl.b	d6,d3
	lsl.b	d6,d5

	move.w	d0,d7
horz_loop:
	move.b	#$FF,d6
	cmp.w	d0,d7
	bne	horz_not_left
	and.b	d2,d6
horz_not_left:
	cmp.w	d1,d7
	bne	horz_not_right
	and.b	d3,d6
horz_not_right:
	or.b	d6,0(a0,d7.w)
	or.b	d6,0(a1,d7.w)
	add.w	#1,d7
	cmp.w	d1,d7
	bls	horz_loop

        lea     30(a0),a2
vert_loop:
	or.b	d4,0(a2,d0.w)
	or.b	d5,0(a2,d1.w)
        lea     30(a2),a2
	cmp.l	a1,a2
	bcs	vert_loop

        movem.l (a7)+,d0-d7/a0-a2
	rts


;-----------------------------------------------------
; Draw a window
;-----------------------------------------------------
draw_Window:
        movem.l d0-d7/a0-a2,-(a7)

        lea     4(a0),a1                ;Title
        move.l  a0,a2                   ;save a0 for after

	addq.l	#4,a0
        moveq.w #3,d0   ;4 laps
        clr.w   d1
\lp     move.b  -(a0),d1
        move.w  d1,-(a7)
        dbra.s  d0,\lp
        bsr     draw_EraseRect
	bsr	draw_FrameRect
	addq.l	#8,a7


	clr.w	d0
        bsr     SetFont

        clr.w   d1                      ;d0 already cleared
        clr.w   d2
        move.b  (a2)+,d0
        move.b  (a2)+,d1
        move.b  (a2),d2

        addq.w  #5,d0                   ;x += 5
        addq.w  #1,d1                   ;y++
        bsr     DrawStringSpecial       ;a1 should be set

        subq.w  #4,d0
        sub.w   d0,d2
        moveq.w #6,d3
        bsr     InvertArea

	movem.l (a7)+,d0-d7/a0-a2
        rts


;-----------------------------------------------------
; Function for size-optimization
;-----------------------------------------------------
DrawStringSpecial:
        movem.l d0-d2/a0-a2,-(a7)
        move.w  #4,-(a7)
        move.l  a1,-(a7)
        move.w  d1,-(a7)
        move.w  d0,-(a7)
        jsr     tios::DrawStrXY
        lea     10(a7),a7
        movem.l (a7)+,d0-d2/a0-a2
        rts

;-----------------------------------------------------
; 
;-----------------------------------------------------
SetFont:
        movem.l d0-d2/a0-a2,-(a7)
        move.w  d0,-(a7)
        jsr     tios::FontSetSys
        addq.l  #2,a7
        movem.l (a7)+,d0-d2/a0-a2
        rts

; Gestion des touches (extrait de flib par David Ellsworth)
;			(extrait de userlib par Xavier Vassor)
; ------------------------------------------------------------------------------------------

	IFD ti92
KB_WAIT:
	movem.l	a0-a6/d1-d7,-(sp)
idle_start:
	move.l	APD_INIT,APD_TIMER	; reset APD timer (1)
	clr.w	APD_FLAG		; reset APD timer (2)
	move.w	#ACTIVITY_IDLE,-(sp)
	jsr	tios::ST_busy
	add.l	#2,sp
wait_idle:
	tst.w	APD_FLAG		; time for APD?
	bne	do_apd
	tst.w	tios::kb_globals+$1C	; has a key been pressed?
	beq	wait_idle
	move.l	APD_INIT,APD_TIMER	; reset APD timer (1)
	move.w	tios::kb_globals+$1E,d0
	clr.w	tios::kb_globals+$1C	; clear key buffer

	move.l	d0,-(sp)
	move.w	#ACTIVITY_BUSY,-(sp)
	jsr	tios::ST_busy
	add.l	#2,sp
	move.l	(sp)+,d0
try_key_off:
	cmp.w	#$210B,d0
	bne	not_key_off
	bra	do_apd
not_key_off:
	movem.l	(sp)+,a0-a6/d1-d7
	rts
do_apd:
	trap	#4
	bra	idle_start
	ENDIF

	IFND ti92
KB_WAIT:
; returns d0 = keycode
idle_loop:
	movem.l d1-d7/a0-a6,-(a7)
	move.w #2,-(a7)
keyloop:
	jsr doorsos::OSTimerExpired	; if APD expired..
	tst.w d0
	beq noshutdown
shutdown:
	trap #4			; then shut down
noshutdown
	tst.w	KEY_PRESSED_FLAG	; has a key been pressed ?
	beq keyloop			; no..
	jsr doorsos::ngetchx		; yes : get the key code
	cmp.w #KEY_DIAMOND+$10B,d0	; Diamand+ON shuts down the calc
	beq shutdown
	move.w d0,d6
	addq.w #1,(a7)
	jsr doorsos::ST_busy
	move.w d6,d0
	addq.l #2,a7
	movem.l (a7)+,d1-d7/a0-a6
	RTS
	ENDIF

;-----------------------------------------------------
; Data
;-----------------------------------------------------
	IFND ti89
OpenWin	dc.b	40,30,199,90
		dc.b	"- Select a level -",0
ErrWin		dc.b	40,45,199,75
		dc.b	"- Error -",0
	ENDIF
	IFD ti89
OpenWin	dc.b	0,30,159,90
		dc.b	"- Select a level -",0
ErrWin		dc.b	0,45,159,75
		dc.b	"- Error -",0
	ENDIF

lvlerr1		dc.b	"No Solar Striker level found.",0
lvlerr2		dc.b	"Internal Error.",0
temp2		dc.b	0
